#ifndef FUNCTIONS_H
#define FUNCTIONS_H 1

#include <inttypes.h>

void reset_input_mode (void);
void signal_handler (int sig);
void Usage (const uint32_t found);
void Error (const int exit, const int errcode, const char *msg);
char * digest2hash (const unsigned char *digest);
void md5crack (void);
void sha1crack (void);
void (*calculation) (void);
void Found (const char *word, const char *chash, const char *ihash, const int mode);
unsigned char * hash2digest (const char *hash);
unsigned char hex2int (const char hex);
uint32_t digestcmp (const unsigned char *digest);
void brute2 (void);
void rf (const int pos);
void print_stats (void);
void Exit (const int status);
unsigned int list_addnode (NODE_T **head, NODE_T *node);
unsigned int list_removenode (NODE_T **head, NODE_T *node);
void bye (void);
uint32_t list_findnode (NODE_T **list, NODE_T *node);
uint32_t hashtype (const char *str);
uint32_t list_countnodes (NODE_T *list);

#endif /* ! FUNCTIONS_H */
